/*********************************************************************

    Windows DIBitmap Input Class Library - Header
            Copyright (c) S.Chiba 1994, 1995, 1996

*********************************************************************/
#ifndef __CDIB_H__
#define __CDIB_H__

class CDIB : public CObject
{
private:
	LPBITMAPINFOHEADER m_bmiHeader;

public:
	WORD GetDepth();
	LONG GetWidth();
	LONG GetHeight();
	int GetDIBPaletteCount();
	LPVOID GetBits();
	LPRGBQUAD GetPalettes();
	HPALETTE GetDIBPalette();
	LONG GetBitSize();
	BOOL CopyPalette( LPVOID );
	BOOL CopyBits( LPVOID );
	void Serialize( CArchive& ar );

	CDIB();
	~CDIB();
	virtual BOOL Create( LONG w, LONG h, int bitcount, int compression );
	virtual void Destroy();
	virtual BOOL DoDraw( CDC* pDc, CRect& destRC, CPoint& offset = CPoint(0,0), int zoom = 100, DWORD dwRop = SRCCOPY );
	virtual BOOL LoadFile( CFile* cfile );
};

#endif // __CDIB_H__
