// KiffSettingsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Kiffref.h"
#include "KiffSettingsDlg.h"
#include "Kiff.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CKiffSettingsDlg dialog


CKiffSettingsDlg::CKiffSettingsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CKiffSettingsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CKiffSettingsDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CKiffSettingsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CKiffSettingsDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CKiffSettingsDlg, CDialog)
	//{{AFX_MSG_MAP(CKiffSettingsDlg)
	ON_WM_HSCROLL()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CKiffSettingsDlg message handlers

void CKiffSettingsDlg::GetParameter( int *mode, int *factor, int *matrix )
{
	*mode = m_mode;
	*factor = m_factor;
	*matrix = m_matrix;
}

void CKiffSettingsDlg::SetFactorView( CScrollBar* pScrollBar, int pos )
{
	if ( pos < 0 ) pos = 0;
	else if ( pos > 15 ) pos = 15;
	pScrollBar->SetScrollPos( pos, TRUE );
	SetDlgItemInt( IDC_EDIT_FACTOR, pos );
}

BOOL CKiffSettingsDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	CButton *Radio;
	CScrollBar *Scroll;
	Scroll = (CScrollBar *) GetDlgItem( IDC_SCROLL_FACTOR );
	Scroll->SetScrollRange( 0, 15, TRUE );
	Radio = (CButton *) GetDlgItem( IDC_KIFF );
	Radio->SetCheck( TRUE );
	Radio = (CButton *) GetDlgItem( IDC_YUV );
	Radio->SetCheck( TRUE );
	SetDlgItemInt( IDC_EDIT_FACTOR, 0 );
	
	m_mode = KIFF_MODE_YUV;
	m_factor = 0;
	m_matrix = Q_KIFF_ORIGINAL;

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CKiffSettingsDlg::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	// TODO: Add your message handler code here and/or call default
	int rscrpos = pScrollBar->GetScrollPos();
	switch( nSBCode )
	{
	case SB_THUMBPOSITION:
	case SB_THUMBTRACK:
		SetFactorView( pScrollBar, nPos );
		break;
	case SB_PAGELEFT:
		SetFactorView( pScrollBar, rscrpos - 3 );
		break;
	case SB_LINELEFT:
		SetFactorView( pScrollBar, rscrpos - 1 );
		break;
	case SB_PAGERIGHT:
		SetFactorView( pScrollBar, rscrpos + 3 );
		break;
	case SB_LINERIGHT:
		SetFactorView( pScrollBar, rscrpos + 1 );
		break;
	}
	
	CDialog::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CKiffSettingsDlg::OnOK() 
{
	// TODO: Add extra validation here
	if ( ((CButton *) GetDlgItem( IDC_YUV ))->GetCheck() ) m_mode = KIFF_MODE_YUV;
	else if ( ((CButton *) GetDlgItem( IDC_RGB ))->GetCheck() ) m_mode = KIFF_MODE_RGB;
	m_factor = GetDlgItemInt( IDC_EDIT_FACTOR );
	if ( ((CButton *) GetDlgItem( IDC_KIFF ))->GetCheck() ) m_matrix = Q_KIFF_ORIGINAL;
	else if ( ((CButton *) GetDlgItem( IDC_JPEG ))->GetCheck() ) m_matrix = Q_JPEG_STANDARD;
	else if ( ((CButton *) GetDlgItem( IDC_CGANIMATION ))->GetCheck() ) m_matrix = Q_CG_ANIMATIONS;
	
	CDialog::OnOK();
}
