// KiffrefDoc.h : interface of the CKiffrefDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_KIFFREFDOC_H__F4A227FD_5006_11D4_8622_0090CC008F78__INCLUDED_)
#define AFX_KIFFREFDOC_H__F4A227FD_5006_11D4_8622_0090CC008F78__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "CDIB.h"
#include "kiff.h"

enum FILE_TYPE
{
	TYPE_NONE,
	TYPE_BITMAP,
	TYPE_KIFF
};

class CKiffrefDoc : public CDocument
{
protected: // create from serialization only
	CKiffrefDoc();
	DECLARE_DYNCREATE(CKiffrefDoc)

// Attributes
public:
	CDIB m_DIB;
	SIZE m_windowSize;
	int m_zooming;
	FILE_TYPE m_type;

	HINSTANCE hInst;
	KIFF* (*KiffProc)();
	VOID (*KiffFree)( KIFF* );
	KIFF* p_kiff;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CKiffrefDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CKiffrefDoc();
	void ReSize();
	void ViewReDraw();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CKiffrefDoc)
	afx_msg void OnFileOpen();
	afx_msg void OnFileSave();
	afx_msg void OnZoom50();
	afx_msg void OnZoom100();
	afx_msg void OnZoom200();
	afx_msg void OnUpdateZoom50(CCmdUI* pCmdUI);
	afx_msg void OnUpdateZoom100(CCmdUI* pCmdUI);
	afx_msg void OnUpdateZoom200(CCmdUI* pCmdUI);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_KIFFREFDOC_H__F4A227FD_5006_11D4_8622_0090CC008F78__INCLUDED_)
